package org.netkernel.mod.xmldb;

import org.netkernel.layer0.nkf.*;
import org.xmldb.api.base.Collection;
import org.xmldb.api.base.XMLDBException;
import org.xmldb.api.modules.CollectionManagementService;

public class Utils
{
	public static Collection getCollection(INKFRequestContext aContext, String aCollection) throws NKFException
	{
		INKFRequest req=aContext.createRequest("active:xmldbCollection");
		req.setRepresentationClass(Collection.class);
		req.addArgument("config", getConfig(aContext));
		req.addArgument("collection", aCollection);
		return (Collection)aContext.issueRequest(req);
	}

	public static Collection createCollection(INKFRequestContext aContext, String aCollection) throws NKFException, XMLDBException
	{	Collection root=getCollection(aContext,"/");
		CollectionManagementService mgtService = (CollectionManagementService)root.getService("CollectionManagementService", "1.0");
		Collection result = mgtService.createCollection(aCollection);	
		return result;
	}
	
	public static void removeCollection(INKFRequestContext aContext, String aCollection) throws NKFException, XMLDBException
	{	Collection root=getCollection(aContext,"/");
		CollectionManagementService mgtService = (CollectionManagementService)root.getService("CollectionManagementService", "1.0");
		mgtService.removeCollection(aCollection);	
	}
	
	
	private static String getConfig(INKFRequestContext aContext)
	{	String config;
		if (aContext.getThisRequest().argumentExists("config"))
		{	config=aContext.getThisRequest().getArgumentValue("config");
		}
		else
		{	config="res:/etc/system/xmldbConfig.xml";
		}
		return config;
	}

}
