package org.netkernel.mod.xmldb;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.util.XMLUtils;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.xmldb.api.base.Collection;
import org.xmldb.api.base.Resource;
import org.xmldb.api.base.ResourceIterator;
import org.xmldb.api.base.ResourceSet;
import org.xmldb.api.modules.XMLResource;
import org.xmldb.api.modules.XPathQueryService;

public class XMLDBQueryAccessor extends StandardAccessorImpl
{
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		String collectionName=aContext.source("arg:operand",String.class);
		Collection c=Utils.getCollection(aContext, collectionName);
		if (c==null)
		{	throw new Exception("collection not found");
		}
		XPathQueryService queryService=(XPathQueryService)c.getService("XPathQueryService", "1.0");
		if (queryService==null)
		{	throw new Exception("XPathQueryService not found");
		}
		queryService.clearNamespaces();
		//TODO specify namespaces
		
		String xpath=aContext.source("arg:operator",String.class);
		
		ResourceSet rs=queryService.query(xpath);
		long size=rs.getSize();
		Document dom;
		if (size==1)
		{	XMLResource res=(XMLResource)rs.getResource(0);
			dom=(Document)res.getContentAsDOM();
		}
		else
		{
			dom=XMLUtils.newDocument();
			Node docElement=dom.createElement("resultset");
			dom.appendChild(docElement);
			ResourceIterator i=rs.getIterator();
			while (i.hasMoreResources())
			{	XMLResource res = (XMLResource)i.nextResource();
				Node n=((Document)res.getContentAsDOM()).getDocumentElement();
				docElement.appendChild(dom.importNode(n, true));
			}
		}
		INKFResponse resp=aContext.createResponseFrom(dom);
		resp.setMimeType("text/plain");
		resp.setNoCache();
	}
	
	
	
}
