package org.netkernel.mod.xmldb;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.xmldb.api.base.Collection;
import org.xmldb.api.modules.XPathQueryService;
import org.xmldb.api.modules.XUpdateQueryService;

public class XMLDBUpdateAccessor extends StandardAccessorImpl
{
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		String collectionName=aContext.source("arg:operand",String.class);
		Collection c=Utils.getCollection(aContext, collectionName);
		if (c==null)
		{	throw new Exception("collection not found");
		}
		XUpdateQueryService queryService=(XUpdateQueryService)c.getService("XUpdateQueryService", "1.0");
		if (queryService==null)
		{	throw new Exception("XUpdateQueryService not found");
		}
		
		String xupdate=aContext.source("arg:operator",String.class);
		long effectedRows=queryService.update(xupdate);
		INKFResponse resp=aContext.createResponseFrom(effectedRows);
		resp.setExpiry(INKFResponse.EXPIRY_ALWAYS);
	}
}
